"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.addToSchema = void 0;
const graphql_1 = require("graphql");
const utils_1 = require("@graphql-tools/utils");
const appsync_dart_extension_visitor_1 = require("./visitors/appsync-dart-extension-visitor");
var appsync_modelgen_plugin_1 = require("@aws-amplify/appsync-modelgen-plugin");
Object.defineProperty(exports, "addToSchema", { enumerable: true, get: function () { return appsync_modelgen_plugin_1.addToSchema; } });
const plugin = (schema, rawDocuments, config) => {
    const visitor = new appsync_dart_extension_visitor_1.AppSyncDartExtensionVisitor(schema, config, {
        selectedType: config.selectedType,
        generate: config.generate,
    });
    if (schema) {
        const schemaStr = (0, utils_1.printSchemaWithDirectives)(schema);
        const node = (0, graphql_1.parse)(schemaStr);
        (0, graphql_1.visit)(node, {
            leave: visitor,
        });
        return visitor.generate();
    }
    return "";
};
exports.plugin = plugin;
//# sourceMappingURL=plugin.js.map