import { AppSyncModelVisitor, ParsedAppSyncModelConfig, RawAppSyncModelConfig, CodeGenModel, CodeGenField } from "@aws-amplify/appsync-modelgen-plugin/lib/visitors/appsync-visitor";
import { DartDeclarationBlock } from "@aws-amplify/appsync-modelgen-plugin/lib/languages/dart-declaration-block";
import { NormalizedScalarsMap } from "@graphql-codegen/visitor-plugin-common";
import type { GraphQLSchema } from "graphql";
export interface RawAppSyncDartExtensionConfig extends RawAppSyncModelConfig {
}
export interface ParsedAppSyncDartExtensionConfig extends ParsedAppSyncModelConfig {
}
export declare class AppSyncDartExtensionVisitor<TRawConfig extends RawAppSyncDartExtensionConfig = RawAppSyncDartExtensionConfig, TPluginConfig extends ParsedAppSyncDartExtensionConfig = ParsedAppSyncDartExtensionConfig> extends AppSyncModelVisitor<TRawConfig, TPluginConfig> {
    constructor(schema: GraphQLSchema, rawConfig: TRawConfig, additionalConfig: Partial<TPluginConfig>, defaultScalars?: NormalizedScalarsMap);
    generate(): string;
    /**
     * Generate classes with model directives
     */
    protected generateModelExtensionClasses(): string;
    protected generateExtensionClass(model: CodeGenModel): string;
    protected generateGetModelMethod(model: CodeGenModel, classDeclarationBlock: DartDeclarationBlock, nullable?: boolean): void;
    protected getModelIdentifierFields(model: CodeGenModel): CodeGenField[];
    protected generatePackageHeader(): string;
}
//# sourceMappingURL=appsync-dart-extension-visitor.d.ts.map